/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 *  ianjuta-editor-autocomplete.c -- Autogenerated from libanjuta.idl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/**
 * SECTION:ianjuta-editor-autocomplete
 * @title: IAnjutaEditorAutocomplete
 * @short_description: Editor autocomplete framework
 * @see_also: 
 * @stability: Unstable
 * @include: libanjuta/interfaces/ianjuta-editor-autocomplete.h
 * 
 * This interface is deprecated in favour of IAnjutaEditorAssist and
 * is only here for backwards compatibility.
 */

#include "ianjuta-editor-autocomplete.h"
#include "libanjuta-iface-marshallers.h"

GQuark 
ianjuta_editor_autocomplete_error_quark (void)
{
	static GQuark quark = 0;
	
	if (quark == 0) {
		quark = g_quark_from_static_string ("ianjuta-editor-autocomplete-quark");
	}
	
	return quark;
}

/**
 * ianjuta_editor_autocomplete_activate:
 * @obj: Self
 * @err: Error propagation and reporting
 *
 * Auto complete current word. This is a left over of old api for
 * backward compatibility. It will be removed once we move to
 * the new api using IAnjutaEditorAssist.
 */
void
ianjuta_editor_autocomplete_activate (IAnjutaEditorAutocomplete *obj, GError **err)
{
	g_return_if_fail (IANJUTA_IS_EDITOR_AUTOCOMPLETE(obj));
	IANJUTA_EDITOR_AUTOCOMPLETE_GET_IFACE (obj)->activate (obj, err);
}

/* Default implementation */
static void
ianjuta_editor_autocomplete_activate_default (IAnjutaEditorAutocomplete *obj, GError **err)
{
	g_return_if_reached ();
}

static void
ianjuta_editor_autocomplete_base_init (IAnjutaEditorAutocompleteIface* klass)
{
	static gboolean initialized = FALSE;

	klass->activate = ianjuta_editor_autocomplete_activate_default;
	
	if (!initialized) {

		initialized = TRUE;
	}
}

GType
ianjuta_editor_autocomplete_get_type (void)
{
	static GType type = 0;
	if (!type) {
		static const GTypeInfo info = {
			sizeof (IAnjutaEditorAutocompleteIface),
			(GBaseInitFunc) ianjuta_editor_autocomplete_base_init,
			NULL, 
			NULL,
			NULL,
			NULL,
			0,
			0,
			NULL
		};
		type = g_type_register_static (G_TYPE_INTERFACE, "IAnjutaEditorAutocomplete", &info, 0);
		g_type_interface_add_prerequisite (type, IANJUTA_TYPE_EDITOR);
	}
	return type;			
}
